searchNodes=[{"doc":"","ref":"LiveSvelte.html","title":"LiveSvelte","type":"module"},{"doc":"Renders a Svelte component on the server. Attributes props ( :map ) - Props to pass to the Svelte component. Defaults to %{} . name ( :string ) (required) - Name of the Svelte component.Examples include &quot;YourComponent&quot; , and &quot;directory/Example&quot; . class ( :string ) - Class to apply to the Svelte component. Defaults to nil . ssr ( :boolean ) - Whether to render the component on the server. Defaults to true . Slots inner_block - Inner block of the Svelte component.","ref":"LiveSvelte.html#render/1","title":"LiveSvelte.render/1","type":"function"},{"doc":"Creates Javascript files to be used by esbuild. Necessary for LiveSvelte to work.","ref":"Mix.Tasks.LiveSvelte.ConfigureEsbuild.html","title":"Mix.Tasks.LiveSvelte.ConfigureEsbuild","type":"task"},{"doc":"","ref":"Mix.Tasks.LiveSvelte.ConfigureEsbuild.html#run/1","title":"Mix.Tasks.LiveSvelte.ConfigureEsbuild.run/1","type":"function"},{"doc":"Configures any necessary code changes inside Phoenix to make LiveSvelte work.","ref":"Mix.Tasks.LiveSvelte.ConfigurePhoenix.html","title":"Mix.Tasks.LiveSvelte.ConfigurePhoenix","type":"task"},{"doc":"","ref":"Mix.Tasks.LiveSvelte.ConfigurePhoenix.html#run/1","title":"Mix.Tasks.LiveSvelte.ConfigurePhoenix.run/1","type":"function"},{"doc":"Installs npm dependencies for LiveSvelte.","ref":"Mix.Tasks.LiveSvelte.InstallNpmDeps.html","title":"Mix.Tasks.LiveSvelte.InstallNpmDeps","type":"task"},{"doc":"","ref":"Mix.Tasks.LiveSvelte.InstallNpmDeps.html#run/1","title":"Mix.Tasks.LiveSvelte.InstallNpmDeps.run/1","type":"function"},{"doc":"Runs all setup tasks for LiveSvelte.","ref":"Mix.Tasks.LiveSvelte.Setup.html","title":"Mix.Tasks.LiveSvelte.Setup","type":"task"},{"doc":"","ref":"Mix.Tasks.LiveSvelte.Setup.html#run/1","title":"Mix.Tasks.LiveSvelte.Setup.run/1","type":"function"},{"doc":"# LiveSvelte Render Svelte directly into Phoenix LiveView with E2E reactivity. ![logo](https://github.com/woutdp/live_svelte/blob/master/logo.png?raw=true) [Resources](#resources) • [Features](#features) • [Demo](#demo) • [Installation](#installation) • [Usage](#usage)","ref":"readme.html","title":"README","type":"extras"},{"doc":"HexDocs HexPackage Phoenix LiveView Blog Post Youtube Introduction","ref":"readme.html#resources","title":"README - Resources","type":"extras"},{"doc":"⚡ End-To-End Reactivity with LiveView 🔋 Server-Side Rendered (SSR) Svelte ⭐ Svelte Preprocessing Support with svelte-preprocess 🦄 Tailwind Support 💀 Dead View Support 🦥 Slot Interoperability (Experimental)","ref":"readme.html#features","title":"README - Features","type":"extras"},{"doc":"/examples/advanced_chat https://user-images.githubusercontent.com/3637265/229902870-29166253-3d18-4b24-bbca-83c4b6648578.webm Svelte handles the look and feel of the chat, while LiveView takes care of syncing. E2E reactivity to the Svelte component so we don't really need to fetch anything! The 'login' to enter your name is a simple LiveView form. Hybrid! /examples/breaking_news https://user-images.githubusercontent.com/3637265/229902860-f7ada6b4-4a20-4105-9ee9-79c0cbad8d72.webm News items are synced with the server while the speed is only client side.","ref":"readme.html#demo","title":"README - Demo","type":"extras"},{"doc":"Phoenix LiveView enables rich, real-time user experiences with server-rendered HTML. It works by communicating any state changes through a websocket and updating the DOM in realtime. You can get a really good user experience without ever needing to write any client side code. LiveSvelte builds on top of Phoenix LiveView to allow for easy client side state management while still allowing for communication over the websocket. Reasons why you'd use LiveSvelte You have (complex) local state You want to use an NPM package You want to take advantage of Svelte's animations You want scoped CSS You like Svelte and its DX :)","ref":"readme.html#why-livesvelte","title":"README - Why LiveSvelte","type":"extras"},{"doc":"For Server-Side Rendering (SSR) to work you need node installed in your environment. Make sure you have it installed in production too. You might be using node only in the build step, but it might actually not be installed in your production environment. You can make sure you have node installed by running node --version in your project directory. If you don't want SSR, you can disable it by not setting NodeJS.Supervisor in application.ex . More on that in the SSR section of this document.","ref":"readme.html#requirements","title":"README - Requirements","type":"extras"},{"doc":"Add live_svelte to your list of dependencies in mix.exs : defp deps do [ { :live_svelte , &quot;~&gt; 0.3.5&quot; } ] end Adjust the setup and assets.deploy aliases in mix.exs : defp aliases do [ setup : [ &quot;deps.get&quot; , &quot;ecto.setup&quot; , &quot;cmd --cd assets npm install&quot; ] , ... , &quot;assets.deploy&quot; : [ &quot;cmd --cd assets node build.js --deploy&quot; , &quot;phx.digest&quot; ] ] end Run the following in your terminal mix deps.get mix live_svelte.setup For tailwind support, add &quot;./svelte/**/*.svelte&quot; to content in the tailwind.config.js file ... content: [ ... &quot;./svelte/**/*.svelte&quot; ], ... Finally, remove the esbuild configuration from config/config.exs and remove the dependency from the deps function in your mix.exs , and you are done! What did we do? You'll notice a bunch of files get created in /assets , as well as some code changes in /lib . This mostly follows from the recommended way of using esbuild plugins, which we need to make this work. You can read more about this here: https://hexdocs.pm/phoenix/asset_management.html#esbuild-plugins In addition we commented out some things such as the esbuild watcher configured in dev.exs that won't be needed anymore, you can delete these comments if desired.","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Svelte components need to go into the assets/svelte directory Set the name of the Svelte component. Optional: Provide the props you want to use that should be reactive as a map to the props field Optional: Provide class to set the class attribute on the root svelte element Optional: Set ssr to false to disable server-side rendering e.g. If your component is named assets/svelte/Example.svelte : def render ( assigns ) do ~H&quot;&quot;&quot; &lt;LiveSvelte.render name=&quot;Example&quot; props={%{number: @number}} /&gt; &quot;&quot;&quot; end If your component is in a directory, for example assets/svelte/some-directory/SomeComponent.svelte you need to include the directory in your name: some-directory/SomeComponent . Examples Examples can be found in the /examples directory. An example project can be found in the /example_project directory. Create a Svelte component &lt;script&gt; // The number prop is reactive, // this means if the server assigns the number, it will update in the frontend export let number = 1 // pushEvent to ... push events to the server. export let pushEvent function increase() { // This pushes the event over the websocket // The last parameter is optional. It's a callback for when the event is finished. // You could for example set a loading state until the event is finished if it takes a longer time. pushEvent(&quot;set_number&quot;, {number: number + 1}, () =&gt; {}) // Note that we actually never set the number in the frontend! // We ONLY push the event to the server. // This is the E2E reactivity in action! // The number will automatically be updated through the LiveView websocket } function decrease() { pushEvent(&quot;set_number&quot;, {number: number - 1}, () =&gt; {}) } &lt;/script&gt; &lt;p&gt;The number is {number}&lt;/p&gt; &lt;button on:click={increase}&gt;+&lt;/button&gt; &lt;button on:click={decrease}&gt;-&lt;/button&gt; Note that here we use the pushEvent function, but you could also use phx-click and phx-value-number if you wanted. Create a LiveView # `/lib/app_web/live/live_svelte.ex` defmodule AppWeb.SvelteLive do use AppWeb , :live_view def render ( assigns ) do ~H&quot;&quot;&quot; &lt;LiveSvelte.render name=&quot;Example&quot; props={%{number: @number}} /&gt; &quot;&quot;&quot; end def handle_event ( &quot;set_number&quot; , %{ &quot;number&quot; =&gt; number } , socket ) do { :noreply , assign ( socket , :number , number ) } end def mount ( _params , _session , socket ) do { :ok , assign ( socket , :number , 5 ) } end end # `/lib/app_web/router.ex` import Phoenix.LiveView.Router scope &quot;/&quot; , AppWeb do ... live &quot;/svelte&quot; , SvelteLive ... end LiveView Live Navigation Events Inside Svelte you can define Live Navigation links. These links navigate from one LiveView to the other without refreshing the page. For example this can be useful when you have a Svelte store and you want this store state to remain during navigation. Example of Svelte store usage can be found in /examples/store . push_navigate &lt;a href=&quot;/your-liveview-path&quot; data-phx-link=&quot;redirect&quot; data-phx-link-state=&quot;push&quot;&gt;Redirect&lt;/a&gt; push_patch &lt;a href=&quot;/your-liveview-path&quot; data-phx-link=&quot;patch&quot; data-phx-link-state=&quot;push&quot;&gt;Patch&lt;/a&gt; LiveView JavaScript Interoperability LiveView allows for a bunch of interoperability which you can read more about here: https://hexdocs.pm/phoenix_live_view/js-interop.html Preprocessor To use the preprocessor, install the desired preprocessor. e.g. Typescript cd assets &amp;&amp; npm install -- save - dev typescript SSR SSR is enabled by default, but if you don't want to use Server-Side Rendering for Svelte, you can do 2 things: Globally If you don't want to use SSR on any component you can disable it globally. This will automatically be the case if you don't include the NodeJs supervisor in you application.ex file Component To disable SSR on a specific component, set the ssr property to false. Like so: &lt; LiveSvelte . render name = &quot;Example&quot; ssr = { false } / &gt;","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"Slot Interoperability Slot interoperability is still experimental, so use with caution! Svelte doesn't have an official way of setting the slot on mounting the Svelte object or updating it on subsequent changes, unlike props. This makes using slots from within Liveview on a Svelte component fragile. The server side rendered initial Svelte rendering does have support for slots so that should work as expected. Slots may eventually reach a state where it is stable, any help in getting there is appreciated. If you know a lot about the internals of Svelte your help may be invaluable here! Any bugs related to this are welcome to be logged, PR's are especially welcome!","ref":"readme.html#caveats","title":"README - Caveats","type":"extras"},{"doc":"Building Static Files Make the changes in /assets/js and run: mix assets.build Or run the watcher: mix assets.build --watch Local Setup Example Project You can use /example_project as a way to test live_svelte locally. Custom Project You can also use your own project. Clone live_svelte to the parent directory of the project you want to test it in. Inside mix.exs { :live_svelte , path : &quot;../live_svelte&quot; } , Inside assets/package.json &quot;live_svelte&quot;: &quot;file:../../live_svelte&quot;, Releasing Update the version in README.md Update the version in package.json Update the version in mix.exs Run: mix hex.publish","ref":"readme.html#development","title":"README - Development","type":"extras"},{"doc":"Ryan Cooke - E2E Reactivity using Svelte with Phoenix LiveView Svonix","ref":"readme.html#credits","title":"README - Credits","type":"extras"}]